angular.module('app.settings').controller('FilterByCorrelationCtrl', function ($rootScope, $scope, $timeout, $q, $element, FilterByCorrelationService, AppService, SQConstants, SQEvents) {
    console.log("FilterByCorrelation controller initialized");

    function init() {
        loaded = false;

        FilterByCorrelationService.loadSettings();

        $timeout(function () {
            loaded = true;
        });
    }

    $scope.settingsChanged = function() {
        if(!loaded) return;

        settingsChanged = true;

        FilterByCorrelationService.saveSettings();
    }
    
    $scope.getCorrelationPeriodLabel = function () {
        var period = getItem($scope.correlationPeriods, 'value', $scope.config.correlation.period);
        return period ? period.name : '';
    }

    $scope.getCorrelationTypeLabel = function () {
        var type = getItem($scope.correlationTypes, 'value', $scope.config.correlation.type);
        return type ? type.name : '';
    }

    //- Event Handlers --------------------------------------------------------------

    $scope.tab.shouldSaveSettings = function(){
        var shouldSaveSettings = settingsChanged;
        settingsChanged = false;
        return shouldSaveSettings;
    }

    function onEvent(event, data) {
        if(event == SQEvents.get('SETTINGS_TAB_ACTIVE')){
            var active = data.title == $scope.tab.title;
            watchersHandler.onActivated(active);
        
        } else if(event == SQEvents.get('SETTINGS_TAB_RELOAD')) {
            if($scope.tab.display && (data == $scope.tab.title || data == 'all')) {
                init();
            }
        }
        else return;
        
        try { $scope.$digest(); } catch(er) {}
    }
    
    $scope.$on("$destroy", function(){
        SQEvents.removeListener(listenerId);
    });


    //- Initialization --------------------------------------------------------------

    $scope.correlationTypes = [];
    $scope.correlationPeriods = [];

    loadToArray($scope.correlationTypes, SQConstants.getConstants().correlationTypes);
    loadToArray($scope.correlationPeriods, SQConstants.getConstants().correlationPeriods);

    var loaded = false;
    
    var settingsChanged = false;
    
    $scope.config = FilterByCorrelationService.config;    

    var listenerId = "FilterByCorrelationCtrl";
    SQEvents.addListener(listenerId, [SQEvents.get('SETTINGS_TAB_ACTIVE'), SQEvents.get('SETTINGS_TAB_RELOAD')], onEvent);

    var watchersHandler = new WatchersHandler($($element));
    $timeout(function(){ watchersHandler.onActivated(false); }, 0, false);

});
