package com.strategyquant.plugin.Settings.impl.FilterByCorrelation;

import com.strategyquant.tradinglib.taskImpl.ISQTask;
import org.jdom2.Element;
import org.json.JSONArray;
import org.json.JSONObject;

import com.strategyquant.lib.L;
import com.strategyquant.lib.XMLUtil;
import com.strategyquant.lib.constants.SQConst;
import com.strategyquant.pluginlib.annotations.Category;
import com.strategyquant.pluginlib.annotations.License;
import com.strategyquant.pluginlib.annotations.Name;
import com.strategyquant.pluginlib.annotations.ShortDesc;
import com.strategyquant.tradinglib.Databank;
import com.strategyquant.tradinglib.SettingsKeys;
import com.strategyquant.tradinglib.correlation.CorrelationSettings;
import com.strategyquant.tradinglib.project.ProjectConfigHelper;
import com.strategyquant.tradinglib.task.settings.ISettingTabPlugin;
import com.strategyquant.tradinglib.task.settings.TaskSettingsData;

import net.xeoh.plugins.base.annotations.PluginImplementation;
import net.xeoh.plugins.base.annotations.meta.Author;

@Author(name = "Tamas Takacs")
@Name(name = "Filter by correlation")
@Category(name = "Settings")
@License(text = "")
@ShortDesc(text = "")
@PluginImplementation
public class SettingsFilterByCorrelation implements ISettingTabPlugin {

	@Override
	public String getProduct() {
		return SQConst.CODE_SQ;
	}

	//------------------------------------------------------------------------
	
	@Override
	public int getPreferredPosition() {
		return 50;
	}

	//------------------------------------------------------------------------
	
	@Override
	public void initPlugin() throws Exception {
		// TODO Auto-generated method stub
		
	}

	//------------------------------------------------------------------------
	
	@Override
	public void readSettings(String projectName, ISQTask task, Element elSettings, TaskSettingsData data) {
		Element elFiltering = null;
		
		try {
			elFiltering = XMLUtil.getChildElem(elSettings, getSettingName());
		} catch(Exception e){
			data.addError(getSettingName(), null, e.getMessage());
			return;
		}
		
		try {			
			Databank dbSource = ProjectConfigHelper.getDatabankByType(projectName, "Source", elSettings);
			Databank dbTarget = ProjectConfigHelper.getDatabankByType(projectName, "Target", elSettings);
			Databank dbExisting = ProjectConfigHelper.getDatabankByType(projectName, "Existing", elSettings);

			data.addParam(SettingsKeys.DatabankSource, dbSource);
			data.addParam(SettingsKeys.DatabankTarget, dbTarget);
			data.addParam("DatabankExisting", dbExisting);		
			
			CorrelationSettings corr = new CorrelationSettings();
			corr.loadFromXml(elFiltering);
			
			data.addParam(SettingsKeys.Correlation, corr);
		} catch(Exception e){
			data.addError(getSettingName(), null, L.t("Cannot load FilterByCorrelation settings. ") + e.getMessage());
		}
	}

	//------------------------------------------------------------------------
	
	@Override
	public void getStrategyConfigSettings(Element elSettings, JSONArray settingsArray) throws Exception {
		// TODO Auto-generated method stub
	}

	//------------------------------------------------------------------------
	
	@Override
	public String getSettingName() {
		return "FilterByCorrelation";
	}

	//------------------------------------------------------------------------
	
	@Override
	public String getName() {
		return L.tsq("Filter by correlation");
	}

	//------------------------------------------------------------------------
	
	@Override
	public JSONObject getInitializationData() throws Exception {
		return null;
	}
}
